// -*- C++ -*-
/*!
 * @file  GPS.cpp
 * @brief Console output component
 * $Date$
 *
 * $Id$
 */

#include "GPS.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <termios.h>

	
	char North_latitude[20];
	char East_longitude[20];
	char Angle_direction[20];
	char Satellite_state;

	char North_latitude1[10];
	char North_latitude2[10];	
	char North_latitude3[10];		
	double North_point,North_point1,North_point2,North_point3;

	char East_longitude1[10];
	char East_longitude2[10];
	char East_longitude3[10];
	double East_point,East_point1,East_point2,East_point3;

	char Angle_direction1[5];
	char Angle_direction2[5];
	double Angle,Angle1,Angle2;


// Module specification
// <rtc-template block="module_spec">
static const char* gps_spec[] =
  {
    "implementation_id", "GPS",
    "type_name",         "GPS",
    "description",       "Console output component",
    "version",           "1.0",
    "vendor",            "MyName",
    "category",          "example",
    "activity_type",     "DataFlowComponent",
    "max_instance",      "10",
    "language",          "C++",
    "lang_type",         "compile",
    // Configuration variables

    ""
  };
// </rtc-template>

GPS::GPS(RTC::Manager* manager)
  : RTC::DataFlowComponentBase(manager),
    // <rtc-template block="initializer">
    m_inIn("in", m_in),
    m_outOut("out", m_out),
    
    // </rtc-template>
	dummy(0)
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  registerInPort("in", m_inIn);
  
  // Set OutPort buffer
  registerOutPort("out", m_outOut);
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

}

GPS::~GPS()
{
}


RTC::ReturnCode_t GPS::onInitialize()
{
  // <rtc-template block="bind_config">
  // Bind variables and configuration variable
  
  // </rtc-template>

	printf("\n********** GPS data acquisition START **********\n");

  return RTC::RTC_OK;
}



/*
RTC::ReturnCode_t GPS::onFinalize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t GPS::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t GPS::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t GPS::onActivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t GPS::onDeactivated(RTC::UniqueId ec_id)
{
	printf("\n********** GPS data acquisition END **********\n");

  return RTC::RTC_OK;
}



RTC::ReturnCode_t GPS::onExecute(RTC::UniqueId ec_id)
{
	if (m_inIn.isNew())
	{
		m_inIn.read();

		if (m_in.data == 1)
		{

//--------------------$B$3$3$+$i(B [GPS$B%G!<%?$N<hF@!&JQ49A`:n(B] $B3+;O(B--------------------//

	//--------------------$B%7%j%"%kDL?.$N@_Dj3+;O(B--------------------//
	// <asm/termbits.h> $B$GDj5A$5$l$F$$$k%\!<%l!<%H$N@_Dj!%$3$l$O(B<termios.h>$B$+$i%$%s%/%k!<%I$5$l$k!#(B
	//#define BAUDRATE B38400
	#define BAUDRATE B57600
	// $BE,@Z$J%7%j%"%k%]!<%H$r;X$9$h$&$K!$$3$NDj5A$rJQ99$9$k!%(B//
	//#define MODEMDEVICE "/dev/ttyS0"		//RS232C $B$G;HMQ$9$k$H$-(B
	#define MODEMDEVICE "/dev/ttyUSB0"		//USB    $B$G;HMQ$9$k$H$-(B
	#define _POSIX_SOURCE 1  // POSIX $B=`5r$N%=!<%9(B //

	#define FALSE 0
	#define TRUE 1

	volatile int STOP=FALSE;

	//--------------------$B%7%j%"%kDL?.$N@_Dj=*N;(B--------------------//


	//--------------------$B%7%j%"%kDL?.$K$h$k(BGPS$B%G!<%?$N<hF@A`:n(B--------------------//
	int fd,c, res;
	struct termios oldtio,newtio;
	char buf[255];
//
//$BFI$_=q$-$N$?$a$K%b%G%`%G%P%$%9$r%*!<%W%s$9$k!%(B
//$B%N%$%:$K$h$C$F(B CTRL-C$B$,$?$^$?$^H/@8$7$F$b@\B3$,@Z$l$J$$$h$&$K!$(Btty $B@)8f$O$7$J$$!%(B
//

	fd = open(MODEMDEVICE, O_RDWR | O_NOCTTY );
	if (fd <0) {perror(MODEMDEVICE); exit(); }

	tcgetattr(fd,&oldtio); // $B8=:_$N%7%j%"%k%]!<%H$N@_Dj$rBTHr$5$;$k(B //
	bzero(&newtio, sizeof(newtio)); // $B?7$7$$%]!<%H$N@_Dj$N9=B$BN$r%/%j%"$9$k(B //

//
//BAUDRATE: $B%\!<%l!<%H$N@_Dj!%(Bcfsetispeed $B$H(B cfsetospeed $B$b;HMQ$G$-$k!%(B
//CRTSCTS : $B=PNO$N%O!<%I%&%'%"%U%m!<@)8f(B
//             
//CS8     : 8n1 (8 $B%S%C%H!$%N%s%Q%j%F%#!$%9%H%C%W%S%C%H(B 1)
//CLOCAL  : $B%m!<%+%k@\B3!$%b%G%`@)8f$J$7(B
//CREAD   : $B<u?.J8;z(B(receiving characters)$B$rM-8z$K$9$k!%(B
//
	newtio.c_cflag = BAUDRATE | CRTSCTS | CS8 | CLOCAL | CREAD;
//
//IGNPAR  : $B%Q%j%F%#%(%i!<$N%G!<%?$OL5;k$9$k(B
//ICRNL   : CR $B$r(B NL $B$KBP1~$5$;$k(B($B$3$l$r9T$o$J$$$H!$B>$N%3%s%T%e!<%?$G(B
//          CR $B$rF~NO$7$F$b!$F~NO$,=*$j$K$J$i$J$$(B)
//$B$=$l0J30$N@_Dj$G$O!$%G%P%$%9$O(B raw $B%b!<%I$G$"$k(B($BB>$NF~NO=hM}$O9T$o$J$$(B)
//
	newtio.c_iflag = IGNPAR | ICRNL;

//
//Raw $B%b!<%I$G$N=PNO(B
//
	newtio.c_oflag = 0;

//
//ICANON  : $B%+%N%K%+%kF~NO$rM-8z$K$9$k(B
//$BA4$F$N%(%3!<$rL58z$K$7!$%W%m%0%i%`$KBP$7$F%7%0%J%k$OAw$i$;$J$$(B
//
	newtio.c_lflag = ICANON;

//
//$BA4$F$N@)8fJ8;z$r=i4|2=$9$k(B
//$B%G%U%)%k%HCM$O(B /usr/include/termios.h $B$r8+$l$PJ,$+$k$,!$%3%a%s%H$K=q(B
//$B$$$F$"$k$N$G!$$3$3$G$O8+$kI,MW$O$J$$!%(B
//
	newtio.c_cc[VINTR]    = 0;     // Ctrl-c //
   	newtio.c_cc[VQUIT]    = 0;     // Ctrl-\ //
	newtio.c_cc[VERASE]   = 0;     // del //
   	newtio.c_cc[VKILL]    = 0;     // @ //
   	newtio.c_cc[VEOF]     = 4;     // Ctrl-d //
   	newtio.c_cc[VTIME]    = 0;     // $B%-%c%i%/%?4V%?%$%^$r;H$o$J$$(B //
   	newtio.c_cc[VMIN]     = 1;     // 1$BJ8;zMh$k$^$G!$FI$_9~$_$r%V%m%C%/$9$k(B //
   	newtio.c_cc[VSWTC]    = 0;     // '\0' //
   	newtio.c_cc[VSTART]   = 0;     // Ctrl-q //
   	newtio.c_cc[VSTOP]    = 0;     // Ctrl-s //
   	newtio.c_cc[VSUSP]    = 0;     // Ctrl-z //
   	newtio.c_cc[VEOL]     = 0;     // '\0' //
   	newtio.c_cc[VREPRINT] = 0;     // Ctrl-r //
   	newtio.c_cc[VDISCARD] = 0;     // Ctrl-u //
   	newtio.c_cc[VWERASE]  = 0;     // Ctrl-w //
   	newtio.c_cc[VLNEXT]   = 0;     // Ctrl-v //
   	newtio.c_cc[VEOL2]    = 0;     // '\0' //

//
//$B%b%G%`%i%$%s$r%/%j%"$7!$%]!<%H$N@_Dj$rM-8z$K$9$k(B
//
   	tcflush(fd, TCIFLUSH);
   	tcsetattr(fd,TCSANOW,&newtio);

//
//$BC<Kv$N@_Dj=*N;!%F~NO$r=hM}$9$k$G$-$k$h$&$K$J$C$?!%(B
//$BNc$G$O!$9T$N@hF,$K(B 'z' $B$rF~NO$9$k$3$H$G%W%m%0%i%`$r=*N;$5$;$k(B
//
//while (STOP==FALSE) {     // $B=*N;>r7o$,K~$?$5$l$k$^$G%k!<%W(B //
//
//255$BJ8;z0J>eF~NO$5$l$?>l9g$G$b!$9T=*C<J8;z$,F~NO$5$l$k$^$G$O!$%W%m(B
//$B%0%i%`$N<B9T$O(B read $B$G%V%m%C%/$5$l$k!%FI$_9~$s$@J8;z?t$,!$<B:]$KF~(B
//$BNO$5$l$F$$$kJ8;z?t$h$j>/$J$$>l9g$K$O!$<!2s$N(B read $B$G;D$j$NJ8;z$,FI(B
//$B$_9~$^$l$k!%JQ?t(B res $B$K$O<B:]$KFI$_9~$^$l$?J8;z?t$,%;%C%H$5$l$k!%(B
//

	printf("\n\n***** gpsdata *****\n");
      res = read(fd,buf,255);
      buf[res]=0;             // printf $B$G;H$&$?$a!$J8;zNs$N=*C<$r%;%C%H$9$k(B //
      printf("%s\n", buf);
      //printf(":%s:%d\n", buf, res);
      
	if (buf[255]==0) STOP=TRUE;
	//if (buf[0]=='z') STOP=TRUE;
   	//}
   	// $B%]!<%H$N@_Dj$r%W%m%0%i%`3+;O;~$N$b$N$KLa$9(B //

	//--------------------GPS$B%G!<%?$N<hF@!&JQ49A`:n$N=hM}(B--------------------//	

	if(buf[17] == 'A'){//$B@5>o$JJ}0L%G!<%?$r<hF@$9$k$?$a$N>r7o3+;O(B

	printf("***** effective gpsdata *****\n");
	
	//--------------------$B0^EY$N<hF@A`:n(B--------------------//
	//char North_latitude[20];
	strncpy(North_latitude,&buf[19],10);
	printf("North_latitude:%s  ",North_latitude);

	//--------------------$B7PEY$N<hF@A`:n(B--------------------//
	//char East_longitude[20];
	strncpy(East_longitude,&buf[32],11);
	printf("East_longitude:%s  \n",East_longitude);
	
	//--------------------$B?J9TJ}0L3QEY$N<hF@A`:n(B--------------------//
	//$B?J9TJ}0L3QEY$N(BGPS$B%G!<%?$,IT0BDj$J$?$a?J9TJ}0L3QEY$O@)8f$K$O;HMQ$7$J$$2DG=@-$,$"$k!#(B
	//char Angle_direction[20];
	strncpy(Angle_direction,&buf[51],6);
	printf("Angle_direction:%s  ",Angle_direction);
	
	//--------------------$BJaB*1R@1>uBV$N<hF@A`:n(B--------------------//
	//$BJaB*1R@1>uBV(B : A$B$OM-8z%G!<%?(B,V$B$OL58z%G!<%?(B
	//char Satellite_state;
	Satellite_state = buf[17];

	printf("Satellite state:%c ",Satellite_state);
	if(Satellite_state == 'A'){
	printf("$BM-8z(B\n");
	}
	else if(Satellite_state == 'V'){
	printf("$BL58z(B\n");
	}

	//--------------------$B0^EY$NJQ49A`:n(B--------------------//	
	//char North_latitude1[10];
	strncpy(North_latitude1,&North_latitude[0],2);
	
	//char North_latitude2[10];
	strncpy(North_latitude2,&North_latitude[2],2);
	
	//char North_latitude3[10];
	strncpy(North_latitude3,&North_latitude[5],5);
		
	//double North_point,North_point1,North_point2,North_point3;
	North_point1 = atoi(North_latitude1);
	North_point2 = atoi(North_latitude2);
	North_point3 = atoi(North_latitude3);
	North_point=(North_point1)+((North_point2)+(North_point3)/100000)/60;	
	//printf("$BKL0^(B:%lf  ",North_point);

	//--------------------$B7PEY$NJQ49A`:n(B--------------------//	
	//char East_longitude1[10];
	strncpy(East_longitude1,&East_longitude[0],3);

	//char East_longitude2[10];
	strncpy(East_longitude2,&East_longitude[3],2);
	
	//char East_longitude3[10];
	strncpy(East_longitude3,&East_longitude[6],5);
	
	//double East_point,East_point1,East_point2,East_point3;
	East_point1 = atoi(East_longitude1);
	East_point2 = atoi(East_longitude2);
	East_point3 = atoi(East_longitude3);
	East_point=(East_point1)+((East_point2)+(East_point3)/100000)/60;	
	//printf("$BEl7P(B:%lf  ",East_point);

	//--------------------$B?J9TJ}0L3QEY$NJQ49A`:n(B--------------------//
	//$B?J9TJ}0L3QEY$N(BGPS$B%G!<%?$,IT0BDj$J$?$a?J9TJ}0L3QEY$O@)8f$K$O;HMQ$7$J$$2DG=@-$,$"$k!#(B	
	//char Angle_direction1[5];
	strncpy(Angle_direction1,&Angle_direction[0],3);
	
	//char Angle_direction2[5];
	strncpy(Angle_direction2,&Angle_direction[4],2);
		
	//double Angle,Angle1,Angle2;
	Angle1 = atoi(Angle_direction1);
	Angle2 = atoi(Angle_direction2);
	Angle=(Angle1) + (Angle2)/100;
		
	//printf("$B?J9TJ}0L3QEY(B:%lf\n",Angle);
	//printf("\n");


			printf("\n********** Data Sending **********\n");

			m_out.data.state = Satellite_state;
			printf("Satellite state : $BM-8z(B %c\n", m_out.data.state);

			m_out.data.north = North_point;
			printf("$BKL0^(B         : %lf\n", m_out.data.north);

			m_out.data.east  = East_point;
			printf("$BEl7P(B         : %lf\n", m_out.data.east);

			m_out.data.angle = Angle;
			printf("$B?J9TJ}0L3QEY(B : %lf\n", m_out.data.angle);

			m_outOut.write();

			printf("********** Data Sending END **********\n");

			sleep(1);//$B%G!<%?<hF@$N<~4|JQ992DG=(B

	}
	else //$B@5>o$J%G!<%?$r<hF@$G$-$J$+$C$?$H$-!":F7WB,$r9T$&(B
	{	printf("***** invalid gpsdata *****\n\n\n");

	}//if(buf[17] == 'A'){//$B@5>o$JJ}0L%G!<%?$r<hF@$9$k$?$a$N>r7o=*N;(B

	} //if (m_in.data == 1)$B=*N;(B
} //if (m_inIn.isNew())$B=*N;(B

  	return RTC::RTC_OK;
}


/*
RTC::ReturnCode_t GPS::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t GPS::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t GPS::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t GPS::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t GPS::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


extern "C"
{
 
  void GPSInit(RTC::Manager* manager)
  {
    RTC::Properties profile(gps_spec);
    manager->registerFactory(profile,
                             RTC::Create<GPS>,
                             RTC::Delete<GPS>);
  }
  
};


