// -*- C++ -*-
/*!
 * @file  GPSControl.cpp
 * @brief Console input component
 * $Date$
 *
 * $Id$
 */

#include "GPSControl.h"
#include "shm_gps.h"

int shm_initialize(key_t shm_key, int shm_size,int *shrd_id,int *shm_ptr);
int shm_access(key_t shm_key, int shm_size, int *shrd_id, int *shm_ptr);

int shd_param_id;
struct SHM_PARAM *param_ptr;
double *data_ptr;
key_t key;

// Module specification
// <rtc-template block="module_spec">
static const char* gpscontrol_spec[] =
  {
    "implementation_id", "GPSControl",
    "type_name",         "GPSControl",
    "description",       "Console input component",
    "version",           "1.0",
    "vendor",            "MyName",
    "category",          "example",
    "activity_type",     "DataFlowComponent",
    "max_instance",      "10",
    "language",          "C++",
    "lang_type",         "compile",
    // Configuration variables

    ""
  };
// </rtc-template>

GPSControl::GPSControl(RTC::Manager* manager)
  : RTC::DataFlowComponentBase(manager),
    // <rtc-template block="initializer">
    m1_inIn("GPSDATA", m1_in),
    m2_inIn("CALDATA", m2_in),
    m1_outOut("ORDER", m1_out),
    m2_outOut("TARGETDATA", m2_out),
    
    // </rtc-template>
	dummy(0)
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  registerInPort("GPSDATA", m1_inIn);
  registerInPort("CALDATA", m2_inIn);
  
  // Set OutPort buffer
  registerOutPort("ORDER", m1_outOut);
  registerOutPort("TARGETDATA", m2_outOut);
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

}

GPSControl::~GPSControl()
{
}


RTC::ReturnCode_t GPSControl::onInitialize()
{
  // <rtc-template block="bind_config">
  // Bind variables and configuration variable

	cout << "Init" << endl;
	// SHM$B$N5/F0(B
	system("./shmexe_gps &");
	sleep(1);

	cout << "shm start" << endl;
	//	GUI$B$N5/F0(B
	system("./GPS-Control &");

	cout << "GUI start" << endl;
	key = ftok(KEYFILE_PATH,PROJ_CHAR);
  if( key == -1 ) {
    perror("ftok()");
  }

  shm_access(key, sizeof(struct SHM_PARAM), &shd_param_id, (int *)&param_ptr);
  param_ptr->shd_param_id = shd_param_id;

  // </rtc-template>
  return RTC::RTC_OK;
}



/*
RTC::ReturnCode_t GPSControl::onFinalize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t GPSControl::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t GPSControl::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t GPSControl::onActivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t GPSControl::onDeactivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t GPSControl::onExecute(RTC::UniqueId ec_id)
{
	m1_out.data = param_ptr->on;
	m1_outOut.write();

	//	$BL\I8:BI8Aw?.(B
	if (param_ptr->mode == 1)
	{
		m2_out.data.north = param_ptr->aim_north;
		m2_out.data.east = param_ptr->aim_east;
		m2_outOut.write();
	}

	//	$B:BI8%G!<%?<hF@(B
	if (m1_inIn.isNew())
	{
		m1_inIn.read();
		
		//	sharedmemory$B$K=q$-9~$_(B
		param_ptr->state = m1_in.data.state;
		param_ptr->north = m1_in.data.north;
		param_ptr->east = m1_in.data.east;
		param_ptr->angle = m1_in.data.angle;
	}

	//	$BL\I8:BI8$^$G$N7W;;7k2L<hF@(B
	if (m2_inIn.isNew())
	{
		m2_inIn.read();

		//	sharedmemory$B$K=q$-9~$_(B
		param_ptr->distance = m2_in.data.d_target;
		param_ptr->turn_angle = m2_in.data.turn_angle;
		param_ptr->direction = m2_in.data.direction;
	}

  return RTC::RTC_OK;
}


/*
RTC::ReturnCode_t GPSControl::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t GPSControl::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t GPSControl::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t GPSControl::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t GPSControl::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{
 
  void GPSControlInit(RTC::Manager* manager)
  {
    RTC::Properties profile(gpscontrol_spec);
    manager->registerFactory(profile,
                             RTC::Create<GPSControl>,
                             RTC::Delete<GPSControl>);
  }
  
};


