// -*- C++ -*-
/*!
 * @file  GPS_analysis.cpp
 * @brief Console output component
 * $Date$
 *
 * $Id$
 */

#include "GPS_analysis.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

	double pi = 3.141592653589793238462; /* $B1_<~N((B $B&P(B */

	int    wp = 1; //waypoint$B99?7$G;HMQ(B

	//--------------------$B<u?.%G!<%?3JG<MQ$NG[Ns(B--------------------//
	char   Satellite_state[2];
	double North_latitude[2];
	double East_longitude[2];
	double Angle[2];


//-------------------------$B#2E@4V5wN%!&2sE>3QEY$N7W;;5Z$S?J9TJ}8~H=Dj$N4X?t(B-------------------------//
void gps_cal(double f0,double g0,double f1,double g1,double f2,double g2,double *pt_d_target,double *pt_turn_angle,char *direction)
{

	//double f0,f1,f2;                                 //$B#2COE@$N0^EY(B($B!k(B) 
	double fr0,fr1,fr2;                                //$B#2COE@$N0^EY(B(rad) 
	//double g0,g1,g2;                                 //$B#2COE@$N7PEY!JEl7P4p=`!K(B($B!k(B) 
	double gr0,gr1,gr2;                                //$B#2COE@$N7PEY!JEl7P4p=`!K(B(rad) 
                                                            
	double h0,h1,h2;					       //$BI89b(B(m)
	double a=6378136.0;                                //$B@VF;H>7B(B(m)
	double e2=0.006694470;                             //$BCO5e$NN%?4N($N<+>h(B
                                                                                                             
	double x0,y0,z0,x1,y1,z1,x2,y2,z2;                 //$B#2COE@$ND>8r:BI8CM(B(m)
	double d_progress,d_target;                        //$B#2COE@4V$ND>5wN%(B(m)
	double s;                                          //$B#2COE@4V$NCOI=LL5wN%(B(m)
	double w;                                          //$B#2COE@4V$NH><MDx3Q(B($B!k(B) ($BCf?43Q$N#1!?#2(B)
	double wr;                                         //$B#2COE@4V$NH><MDx3Q(B(rad)
	double rad;                                        //$BEY"*%i%8%"%sJQ4978?t(B
	double N0,N1,N2;                                   //$B0^EYJd@5$7$?CO5e$NH>7B(B(m)
 
	double dotproduct;					   //$BFb@Q$N7W;;(B
	double x_progress_vector,y_progress_vector,z_progress_vector;//$B?J9TJ}8~$N%Y%/%H%k(B
	double x_target_vector,y_target_vector,z_target_vector;      //$BL\I8J}8~$N%Y%/%H%k(B
	double cos_theta;					   //$BFb@Q7W;;$N3QEY(B(cos_theta)
	double turn_angle;				          //$B2sE>3QEY(B
	double outerproduct;				   //$B30@Q$N7W;;(B
	//char   direction[10];
    
	rad=pi/180.0;					   //$BEY"*%i%8%"%sJQ497W;;(B
	h0=h1=h2=0.0;                                      //$B$3$3$G$O!"I89b$rL5;k(B
  
	//$BBh(B0$BCOE@(B($B?tICA0$N0LCV(B)$B$N0^EY!"7PEY$N%i%8%"%sI=<(JQ49(B
	if(g0<0) g0=360.0+g0;
	fr0=f0*rad; gr0=g0*rad;  
	//$BBh(B1$BCOE@(B($B8=:_0LCV(B)$B$N0^EY!"7PEY$N%i%8%"%sI=<(JQ49(B
	if(g1<0) g1=360.0+g1;
	fr1=f1*rad; gr1=g1*rad;
	//$BBh(B2$BCOE@(B($BL\I80LCV(B)$B$N0^EY!"7PEY$N%i%8%"%sI=<(JQ49(B
	if(g2<0) g2=360.0+g2;
	fr2=f2*rad; gr2=g2*rad;
 
	//$BBh(B0$BCOE@(B($B?tICA0$N0LCV(B)$B$N0^EY!"7PEY$ND>8r:BI8JQ49(B
	N0=a/(sqrt(1.0-e2*sin(fr0)*sin(fr0)));             //$B0^EYJd@5$7$?CO5e$NH>7B(B(m)N0$B$N7W;;(B
	x0=(N0+h0)*cos(fr0)*cos(gr0);			   //x0$BCOE@$ND>8r:BI8CM(B(m)
	y0=(N0+h0)*cos(fr0)*sin(gr0);			   //y0$BCOE@$ND>8r:BI8CM(B(m)
	z0=(N0*(1.0-e2)+h0)*sin(fr0);			   //z0$BCOE@$ND>8r:BI8CM(B(m)
 
	//$BBh(B1$BCOE@(B($B8=:_0LCV(B)$B$N0^EY!"7PEY$ND>8r:BI8JQ49(B
	N1=a/(sqrt(1.0-e2*sin(fr1)*sin(fr1)));             //$B0^EYJd@5$7$?CO5e$NH>7B(B(m)N1$B$N7W;;(B
	x1=(N1+h1)*cos(fr1)*cos(gr1);			   //x1$BCOE@$ND>8r:BI8CM(B(m)
	y1=(N1+h1)*cos(fr1)*sin(gr1);			   //y1$BCOE@$ND>8r:BI8CM(B(m)
	z1=(N1*(1.0-e2)+h1)*sin(fr1);			   //z1$BCOE@$ND>8r:BI8CM(B(m)
 
	//$BBh(B2$BCOE@(B($BL\I80LCV(B)$B$N0^EY!"7PEY$ND>8r:BI8JQ49(B
	N2=a/(sqrt(1.0-e2*sin(fr2)*sin(fr2)));             //$B0^EYJd@5$7$?CO5e$NH>7B(B(m)N2$B$N7W;;(B
	x2=(N2+h2)*cos(fr2)*cos(gr2);			   //x2$BCOE@$ND>8r:BI8CM(B(m)
	y2=(N2+h2)*cos(fr2)*sin(gr2);			   //y2$BCOE@$ND>8r:BI8CM(B(m)
	z2=(N2*(1.0-e2)+h2)*sin(fr2);			   //z2$BCOE@$ND>8r:BI8CM(B(m)
 
	//$B0\F05wN%7W;;(B($B?tICA0$N0LCV"*8=:_0LCV$N#2E@4V5wN%(B)
	d_progress=sqrt((x1-x0)*(x1-x0)+(y1-y0)*(y1-y0)+(z1-z0)*(z1-z0));
	//$BL\I85wN%7W;;(B($B8=:_0LCV"*L\I80LCV$N#2E@4V5wN%(B)                                
	d_target=*pt_d_target=sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1)+(z2-z1)*(z2-z1));

	x_progress_vector = x1-x0;                         //x$B<4$N?J9TJ}8~$N%Y%/%H%k(B
	y_progress_vector = y1-y0;                         //y$B<4$N?J9TJ}8~$N%Y%/%H%k(B
	z_progress_vector = z1-z0;				//z$B<4$N?J9TJ}8~$N%Y%/%H%k(B
	x_target_vector = x2-x1;				   //x$B<4$NL\I8J}8~$N%Y%/%H%k(B
	y_target_vector = y2-y1;				   //y$B<4$NL\I8J}8~$N%Y%/%H%k(B
	z_target_vector = z2-z1;				   //z$B<4$NL\I8J}8~$N%Y%/%H%k(B
 
	//$B?J9TJ}8~$HL\I8J}8~%Y%/%H%k$NFb@Q7W;;(B
	dotproduct = x_progress_vector*x_target_vector
		      +y_progress_vector*y_target_vector
		      +z_progress_vector*z_target_vector;
	//$B3QEY(B(cos_theta)$B$N7W;;(B
	cos_theta = dotproduct/(d_progress*d_target);
	//$B2sE>3QEY$N7W;;(B
	turn_angle = *pt_turn_angle = acos(cos_theta)*(180/pi);
	//$B30@Q$N7W;;(B($B1?F0@)8f(B $B:8@{2s(B or $B1&@{2s(B $B$rH=Dj$9$k$?$a$N7W;;(B)
	outerproduct = (x_progress_vector*y_target_vector) - (y_progress_vector*x_target_vector);
 
	printf("\n***** gps calculation *****\n"); 
	printf("x0$B!'(B%lf y0$B!'(B%lf\n",x0,y0);
	printf("x1$B!'(B%lf y1$B!'(B%lf\n",x1,y1);
	printf("x2$B!'(B%lf y2$B!'(B%lf\n",x2,y2);
	printf("progress_distance $B!'(B%9.3lf m\n",d_progress);
	printf("target_distance   $B!'(B%9.3lf m\n",d_target);
	printf("turn_angle         :%10.6lf$B!k(B\n",turn_angle);
 
	//($B1?F0@)8f(B $B:8@{2s(B or $B1&@{2s(B or $BA0?J(B $B$rH=Dj$9$k$?$a$N=hM}(B)
	if(outerproduct > 0 && turn_angle >= 20){
	*direction = 'L';
	printf("$BJ}8~H=Dj!!(B:  %c $B:8@{2s(B\n",*direction);
	printf("turn_angle = %d$B!k(B\n",(int)(turn_angle));

 }
 else if(outerproduct < 0 && turn_angle >= 20){
	*direction = 'R';
 	printf("$BJ}8~H=Dj!!(B:  %c $B1&@{2s(B\n",*direction);
	printf("turn_angle = %d$B!k(B\n",(int)(turn_angle));

 }
 else if(turn_angle <= 20){
	*direction = 'S';
 	printf("$BJ}8~H=Dj!!(B:  %c $BA0?J(B\n",*direction);

 } 
 
 /*
 //waypoint$B$NE~CeH=Dj(B
 if(d_target <= 2){
 printf("waypoint judgment  : $BE~Ce(B\n");}
 else{
 printf("waypoint judgment  : $BL$E~Ce(B\n");}
 */
 //printf("\n");
 
 return;
 
}//$B#2E@4V5wN%!&2sE>3QEY$N7W;;5Z$S?J9TJ}8~H=Dj$N4X?t$N=*N;(B


// Module specification
// <rtc-template block="module_spec">
static const char* gps_analysis_spec[] =
  {
    "implementation_id", "GPS_analysis",
    "type_name",         "GPS_analysis",
    "description",       "Console output component",
    "version",           "1.0",
    "vendor",            "MyName",
    "category",          "example",
    "activity_type",     "DataFlowComponent",
    "max_instance",      "10",
    "language",          "C++",
    "lang_type",         "compile",
    // Configuration variables

    ""
  };
// </rtc-template>

GPS_analysis::GPS_analysis(RTC::Manager* manager)
  : RTC::DataFlowComponentBase(manager),
    // <rtc-template block="initializer">
    m1_inIn("in", m1_in),
    m2_inIn("in", m2_in),
    m_outOut("out", m_out),
    
    // </rtc-template>
	dummy(0)
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  registerInPort("in", m1_inIn);
  registerInPort("in", m2_inIn);
  
  // Set OutPort buffer
  registerOutPort("out", m_outOut);
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

}

GPS_analysis::~GPS_analysis()
{
}


RTC::ReturnCode_t GPS_analysis::onInitialize()
{
  // <rtc-template block="bind_config">
  // Bind variables and configuration variable
  
  // </rtc-template>
  return RTC::RTC_OK;
}



/*
RTC::ReturnCode_t GPS_analysis::onFinalize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t GPS_analysis::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t GPS_analysis::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t GPS_analysis::onActivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t GPS_analysis::onDeactivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t GPS_analysis::onExecute(RTC::UniqueId ec_id)
{
	double pt_d_target;
	double pt_turn_angle;
	char   direction;

	//--------------------$BL\I80LCVFI$_9~$_@_Dj(B--------------------//
	double North_waypoint[100];
	double East_waypoint[100];
	m2_inIn.read();
	North_waypoint[wp] = m2_in.data.north;
	East_waypoint[wp]  = m2_in.data.east;
	//--------------------$BL\I80LCVFI$_9~$_@_Dj(B $B=*N;(B--------------------//

	if(m1_inIn.isNew())
	{
		m1_inIn.read();
		Satellite_state[0] = m1_in.data.state;
		North_latitude[0]  = m1_in.data.north;
		East_longitude[0]  = m1_in.data.east;
		Angle[0]           = m1_in.data.angle;

		//printf("\n********** Data Receiving0 **********\n");
		//printf("Satellite state : $BM-8z(B %c\n", Satellite_state[0]);
		//printf("$BKL0^(B         : %lf\n", North_latitude[0]);
		//printf("$BEl7P(B         : %lf\n", East_longitude[0]);
		//printf("$B?J9TJ}0L3QEY(B : %lf\n", Angle[0]);
		//printf("********** Data Receiving0 END **********\n");

		usleep(5000000);//$B2r@O=hM}$N<~4|$rJQ992DG=(B

		m1_inIn.read();
		Satellite_state[1] = m1_in.data.state;
		North_latitude[1]  = m1_in.data.north;
		East_longitude[1]  = m1_in.data.east;
		Angle[1]           = m1_in.data.angle;

		//printf("\n********** Data Receiving1 **********\n");
		//printf("Satellite state : $BM-8z(B %c\n", Satellite_state[1]);
		//printf("$BKL0^(B         : %lf\n", North_latitude[1]);
		//printf("$BEl7P(B         : %lf\n", East_longitude[1]);
		//printf("$B?J9TJ}0L3QEY(B : %lf\n", Angle[1]);
		//printf("********** Data Receiving1 END **********\n");


	if(North_latitude[0] != North_latitude[1] && East_longitude[0] != East_longitude[1]){

	gps_cal
	(North_latitude[0],East_longitude[0],North_latitude[1],East_longitude[1],North_waypoint[wp],East_waypoint[wp],&pt_d_target,&pt_turn_angle,&direction);

			printf("\n********** Data Sending **********\n");

			m_out.data.d_target   = pt_d_target;
			printf("target_distance $B!'(B%9.3lf m\n", m_out.data.d_target);

			m_out.data.turn_angle = pt_turn_angle;
			printf("turn_angle      :%10.6lf$B!k(B\n", m_out.data.turn_angle);

			m_out.data.direction  = direction;
			printf("$BJ}8~H=Dj(B        :  %c \n", m_out.data.direction);

			m_outOut.write();

			printf("********** Data Sending END **********\n");

		}
	else{
	printf("\n********** You are stopping! **********\n");
	}

	} //if(m_inIn.isNew())$B=*N;(B
  return RTC::RTC_OK;
}


/*
RTC::ReturnCode_t GPS_analysis::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t GPS_analysis::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t GPS_analysis::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t GPS_analysis::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t GPS_analysis::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{
 
  void GPS_analysisInit(RTC::Manager* manager)
  {
    RTC::Properties profile(gps_analysis_spec);
    manager->registerFactory(profile,
                             RTC::Create<GPS_analysis>,
                             RTC::Delete<GPS_analysis>);
  }
  
};


