// -*- C++ -*-
/*!
 * @file  GPS_datalog.cpp
 * @brief Console output component
 * $Date$
 *
 * $Id$
 */

#include "GPS_datalog.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


	char Satellite_state[2];//$BJaB*1R@1>uBV(B : A$B$OM-8z%G!<%?(B,V$B$OL58z%G!<%?(B
	double North_latitude[2];//$BKL0^(B
	double East_longitude[2];//$BEl7P(B
	double Angle[2];//$B?J9TJ}0L3QEY(B
	FILE *fpout;

// Module specification
// <rtc-template block="module_spec">
static const char* gps_datalog_spec[] =
  {
    "implementation_id", "GPS_datalog",
    "type_name",         "GPS_datalog",
    "description",       "Console output component",
    "version",           "1.0",
    "vendor",            "MyName",
    "category",          "example",
    "activity_type",     "DataFlowComponent",
    "max_instance",      "10",
    "language",          "C++",
    "lang_type",         "compile",
    // Configuration variables

    ""
  };
// </rtc-template>

GPS_datalog::GPS_datalog(RTC::Manager* manager)
  : RTC::DataFlowComponentBase(manager),
    // <rtc-template block="initializer">
    m_inIn("in", m_in),
    
    // </rtc-template>
	dummy(0)
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  registerInPort("in", m_inIn);
  
  // Set OutPort buffer
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

}

GPS_datalog::~GPS_datalog()
{
}


RTC::ReturnCode_t GPS_datalog::onInitialize()
{
  // <rtc-template block="bind_config">
  // Bind variables and configuration variable
  
  // </rtc-template>
  return RTC::RTC_OK;
}



/*
RTC::ReturnCode_t GPS_datalog::onFinalize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t GPS_datalog::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t GPS_datalog::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t GPS_datalog::onActivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t GPS_datalog::onDeactivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t GPS_datalog::onExecute(RTC::UniqueId ec_id)
{
	if(m_inIn.isNew())
	{
		m_inIn.read();
		Satellite_state[0] = m_in.data.state;
		North_latitude[0]  = m_in.data.north;
		East_longitude[0]  = m_in.data.east;
		Angle[0]           = m_in.data.angle;

		sleep(1);

		m_inIn.read();
		Satellite_state[1] = m_in.data.state;
		North_latitude[1]  = m_in.data.north;
		East_longitude[1]  = m_in.data.east;
		Angle[1]           = m_in.data.angle;

	if(North_latitude[0] != North_latitude[1] || East_longitude[0] != East_longitude[1]){

		//--------------------$B%U%!%$%k$NDI2C=q$-9~$_!!3+;O(B--------------------//
		if( (fpout = fopen("datalog.txt","a")) == NULL)
		{
		fclose(fpout);
		printf("can't open datalog.txt\n");
		exit();
		}  

		printf("********** Data Saving **********\n");

		Satellite_state[1] = m_in.data.state;
		printf("Satellite_state : %c\n", Satellite_state[1]);

		North_latitude[1]  = m_in.data.north;
		printf("North_latitude  : %lf\n", North_latitude[1]);
		fprintf(fpout,"%lf",North_latitude[1]);

		East_longitude[1]  = m_in.data.east;
		printf("East_longitude  : %lf\n", East_longitude[1]);
		fprintf(fpout,"	%lf\n",East_longitude[1]);

		Angle[1] = m_in.data.angle;
		printf("Angle           : %lf\n", Angle[1]);

		fclose(fpout);//$B%U%!%$%k$NDI2C=q$-9~$_!!=*N;(B

		printf("********** Data Saving END ******\n\n");

		}
	}//if(m_inIn.isNew()) $B=*N;(B
  return RTC::RTC_OK;
}


/*
RTC::ReturnCode_t GPS_datalog::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t GPS_datalog::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t GPS_datalog::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t GPS_datalog::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t GPS_datalog::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{
 
  void GPS_datalogInit(RTC::Manager* manager)
  {
    RTC::Properties profile(gps_datalog_spec);
    manager->registerFactory(profile,
                             RTC::Create<GPS_datalog>,
                             RTC::Delete<GPS_datalog>);
  }
  
};


